package com.chinacreator.datasync.common;

import java.util.HashMap;
import java.util.Map;

import com.chinacreator.datasync.entity.JobStatusInfoBean;

/**
 * 
 * Job运行状态工具类
 * 
 * @author maoya
 *
 */
public class ShareVarUtil {
	
	// 用于存储当前运行中 job 的信息
	public static Map<String,JobStatusInfoBean> jobStatusInfo = new HashMap<String,JobStatusInfoBean>();
	
	// 设置 job中 发送数据的线程数量
	public static void setJobSendThreadNum(String jobName,int sendThreadNum){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			infoBean = new JobStatusInfoBean();
		}
		infoBean.setSendThreadNum(sendThreadNum);
		jobStatusInfo.put(jobName, infoBean);
	}
	
	public static synchronized void addJobSendThreadNum(String jobName,int add) {
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			infoBean = new JobStatusInfoBean();
		}
		infoBean.setSendThreadNum(infoBean.getSendThreadNum()+add);
		jobStatusInfo.put(jobName, infoBean);
    }

	
	// 获取  job中 发送数据的线程数量
	public static int getJobSendThreadNum(String jobName){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			return 0;
		}
		return infoBean.getSendThreadNum();
	}
	
	
	// 设置 job中 发送数据的线程数量
	public static void setJobConsumerThreadNum(String jobName,int consumerThreadNum){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			infoBean = new JobStatusInfoBean();
		}
		infoBean.setConsumerThreadNum(consumerThreadNum);
		jobStatusInfo.put(jobName, infoBean);
	}
	public static synchronized void addJobConsumerThreadNum(String jobName,int add) {
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			infoBean = new JobStatusInfoBean();
		}
		infoBean.setConsumerThreadNum(infoBean.getConsumerThreadNum()+add);
		jobStatusInfo.put(jobName, infoBean);
    }
	
	// 获取  job中 发送数据的线程数量
	public static int getJobConsumerThreadNum(String jobName){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			return 0;
		}
		return infoBean.getConsumerThreadNum();
	}
	

		
	public static void setJobStatusInfo(String jobName,JobStatusInfoBean infoBean){
		jobStatusInfo.put(jobName, infoBean);
	}
		
	public static JobStatusInfoBean getJobStatusInfo(String jobName){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			return null;
		}
		return infoBean;
	}
	
	public static void setJobStatus(String jobName,String setJobStatus){
		JobStatusInfoBean infoBean = jobStatusInfo.get(jobName);
		if(infoBean==null){
			infoBean = new JobStatusInfoBean();
		}
		
		infoBean.setStatus(setJobStatus);
		jobStatusInfo.put(jobName, infoBean);
	}

	
	
}
