package com.chinacreator.datasync.dao;

import java.util.HashMap;
import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.chinacreator.datasync.entity.DataSyncJobBean;
import com.chinacreator.datasync.entity.OrderSyncKafkaBeanResult;
import com.chinacreator.datasync.entity.SyncOrderBean;

@Mapper
public interface QueryDbDao {
	
	public List<DataSyncJobBean>  querySyncJob();
	
	public List<DataSyncJobBean>  querySyncJobByType(@Param(value = "dealtype")String dealtype);
	
	public List<String>  queryFhXhCpid();
	
	public List<String>  queryFhXh(@Param(value = "cpid")String cpid);
	
	
	/**
	 * 查询复合及后向产品的订购关系
	 * 
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @return
	 */
	public List<SyncOrderBean> getSyncOrderBeanList(@Param(value = "userid")String userid ,
			@Param(value = "cpid")String cpid,
			@Param(value = "spid")String spid);
	
	/**
	 * 更新同步标记表同步状态
	 * 
	 * @param syncid
	 * @param userid
	 * @param synctype
	 * @param synccpid
	 * @param syncstatus
	 * @return
	 */
	public int updateSyncLog(@Param(value = "syncid")String syncid,
			@Param(value = "userid")String userid,
			@Param(value = "synctype")String synctype,
			@Param(value = "synccpid")String synccpid,
			@Param(value = "syncstatus")String syncstatus,
			@Param(value = "syncinfo")String syncinfo);
	
	/**
	 * 
	 * 保存CP同步日志
	 * 
	 * @param log
	 * @return
	 */
	public int insertCpSyncSendLog(OrderSyncKafkaBeanResult log);
	
	/**
	 * 保存cdn同步日志
	 * 
	 * @param log
	 * @return
	 */
	public int insertCdnSyncSendLog(OrderSyncKafkaBeanResult log);
	
	
	/**
	 * 获取当前时间
	 * @return
	 */
	public String getCurrtime();
	
	/**
	 * 获取订购关系表id
	 * @param userid
	 * @param cpid
	 * @param spid
	 * @return
	 */
	public List<HashMap> getRealIds(@Param(value = "userid")String userid ,
			@Param(value = "cpid")String cpid,
			@Param(value = "spid")String spid);

	/**
	 * 更新监控值
	 * @param sql
	 * @return
	 */
	int updMonitorBySql(String sql);


	/**
	 * 获取监控配置
	 * @return
	 */
	List<HashMap> getMonitorConf();
	
	/**
	 * 获取所有前向业务
	 * @return
	 */
	List<String> hasDirecBusi();

	/**
	 * 获取所有参与送流量的产品
	 * @return
	 */
	List<String> getSendflowpro();

	/**
	 * 更新伪码同步标记表同步状态
	 *
	 * @param syncid
	 * @param userid
	 * @param synctype
	 * @param synccpid
	 * @param syncstatus
	 * @return
	 */
	public int updateFakeidsSync(@Param(value = "syncid")String syncid,
							 @Param(value = "userid")String userid,
							 @Param(value = "synctype")String synctype,
							 @Param(value = "synccpid")String synccpid,
							 @Param(value = "syncstatus")String syncstatus,
							 @Param(value = "syncinfo")String syncinfo);

}
