package com.chinacreator.datasync.job;

import java.util.Arrays;
import java.util.Properties;

import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.chinacreator.datasync.kafka.KafkaProductor;
import com.chinacreator.datasync.services.SyncService;
import com.chinacreator.datasync.util.SpringContextUtils;

/**
 * 
 * 数据同步测试
 * @author xu.zhou
 * 20210422
 */
@Component
public class TaskSynTestJob {
	
	private boolean hasrun = false;
	/****
	@Scheduled(fixedDelayString = "${config.job.sync.fixedDelay}")  
	public void task(){
		try {
			if(hasrun == false){
				System.out.println("++++++++++++++++++++++++开始创建客户端++++++++++++");
				hasrun = true;
				Properties props = new Properties();
				//在启动consumer时配置的broker地址的。不需要将cluster中所有的broker都配置上，因为启动后会自动的发现cluster所有的broker。
				//它配置的格式是：host1:port1;host2:port2…
				props.put("bootstrap.servers", "10.0.17.71:30991,10.0.17.86:30992,10.0.17.82:30993");
				//设置GROUPID，用于表示该consumer想要加入到哪个group中。默认值是 ""
				props.put("group.id", "test_hlx_realtime_order_topic");
				//Consumer 在commit offset时有两种模式：自动提交，手动提交。手动提交在前面已经说过。自动提交：是Kafka Consumer会在后台周期性的去commit。
				//默认值是true。
				props.put("enable.auto.commit", "true");//设置自动提交
				//自动提交间隔。范围：[0,Integer.MAX]，默认值是 5000 （5 s）
				props.put("auto.commit.interval.ms", "1000");
				//Consumer session 过期时间。这个值必须设置在broker configuration中的group.min.session.timeout.ms 与 group.max.session.timeout.ms之间。
				//其默认值是：10000 （10 s）
				props.put("session.timeout.ms", "30000");
		        //每次取数据条数， 一次调用poll()操作时返回的最大记录数，默认值为500
				props.put("max.poll.records", 20); //20
		        //请求发起后，并不一定会很快接收到响应信息。这个配置就是来配置请求超时时间的。默认值是：305000 （305 s）
				props.put("request.timeout.ms", "40000");
		        
					//当consumer向一个broker发起fetch请求时，broker返回的records的大小最小值。如果broker中数据量不够的话会wait，直到数据大小满足这个条件。
					//取值范围是：[0, Integer.Max]，默认值是1。
					//默认值设置为1的目的是：使得consumer的请求能够尽快的返回。
		         
				props.put("fetch.min.bytes", "1");
		        
		            // 这个配置项，是告诉Kafka Broker在发现kafka在没有初始offset，或者当前的offset是一个不存在的值（如果一个record被删除，就肯定不存在了）时，该如何处理。它有4种处理方式：
					//1） earliest：自动重置到最早的offset。
					//2） latest：看上去重置到最晚的offset。
					//3） none：如果边更早的offset也没有的话，就抛出异常给consumer，告诉consumer在整个consumer group中都没有发现有这样的offset。
					//4） 如果不是上述3种，只抛出异常给consumer。
					//默认值是latest。
		        
				props.put("auto.offset.reset", "earliest");//earliest,latest
		        //Message record 的key, value的反序列化类。
				props.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
				props.put("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
		        KafkaConsumer<String, String> consumer=new KafkaConsumer<String, String>(props);
		        System.out.println("-----------------客户端创建完成");
				try{
					consumer.subscribe(Arrays.asList("test_hlx_realtime_order_topic"));
					System.out.println("-------------获取tpic数据");
					while (true) {
						ConsumerRecords<String, String> records = consumer.poll(100);
						if(records.count() > 0){
							for (ConsumerRecord<String, String> record : records) {
								String rectopic = record.topic();
								int partition = record.partition();
								long offset = record.offset();
								String key = record.key();
								String dataJson = record.value();
								System.out.println("=================dataJson:"+dataJson);
							}
						}else{
							System.out.println("-----------无数据");
						}
					}
				}catch(Exception e){
					e.printStackTrace();
					System.out.println("=================出现异常："+e.getMessage());
				}
			}
		} catch (Exception e) {}
	}
	****/
}
