package com.chinacreator.datasync.services;

import com.alibaba.druid.util.StringUtils;
import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.util.SpringContextUtils;
import com.chinacreator.datasync.util.ThreadLimitUtil;
import org.apache.log4j.Logger;
import org.quartz.*;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

/**
 * 监控
 *
 * @author zhengrong.yan
 * @date 20210531
 */
@Service
public class MonitorQuartz  {

    private static Logger logger = Logger.getLogger("monitorQuartz");

    public void execute()  {
        try {
            //获取配置信息
            logger.info("monitor start!!");
            QueryDbDao kafkaInfo = (QueryDbDao) SpringContextUtils.getBean(QueryDbDao.class);
            List<HashMap> monitorList = kafkaInfo.getMonitorConf();
            String monisql = "";
            String monitype = "";
            String id = "";
            int rows = 0;
            String exesql = "";
            logger.info("consLiveMap=>" + ThreadLimitUtil.consLiveMap);
            for (HashMap hm : monitorList) {
                monisql = (String) hm.get("MONISQL"); //执行SQL，或者其他变量
                monitype = (String) hm.get("MONITYPE");
                id = hm.get("ID").toString();
                //执行内存队列监控
                if ("1".equals(monitype) && monisql != null) {
                    boolean res = false;
                    logger.info("队列====>"+monisql + "__queue");
                    logger.info(ThreadLimitUtil.sharedQueueMap.get(monisql + "__queue"));
                    if (ThreadLimitUtil.sharedQueueMap.get(monisql + "__queue") != null) {
                        res = ThreadLimitUtil.sharedQueueMap.get(monisql + "__queue");
                        if (res) {  //true 代表积压
                            exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 1 WHERE ID = '" + id + "'";
                        } else {   //false 未积压
                            exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 0 WHERE ID = '" + id + "'";
                        }
                    } else {
                        exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 2 WHERE ID = '" + id + "'";
                    }
                    try {
                        rows = kafkaInfo.updMonitorBySql(exesql);
                        //System.out.println(id+"，执行SQL影响行："+rows);
                    } catch (Exception e) {
                        e.printStackTrace();
                        logger.error(exesql + "，执行SQL出现异常，" + e.getMessage(), e);
                    }

                    //执行topic消费端存活监控
                } else if ("2".equals(monitype) && monisql != null) {
                    String consLiveMaxTime = (String) hm.get("EXTEND1");
                    if (StringUtils.isEmpty(consLiveMaxTime)) {
                        consLiveMaxTime = "300";
                    }
                    //获取topic消费存活状态
                    boolean res = ThreadLimitUtil.hasConsLive(monisql, Long.parseLong(consLiveMaxTime));
                    if (res) {
                        //设置监控结果为活跃状态
                        exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 0 WHERE ID = '" + id + "'";
                    } else {
                        //设置监控结果为消亡状态
                        exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 1 WHERE ID = '" + id + "'";
                    }
                    try {
                        rows = kafkaInfo.updMonitorBySql(exesql);
                        //System.out.println(id+"，执行SQL影响行："+rows);
                    } catch (Exception e) {
                        e.printStackTrace();
                        logger.error(exesql + "，执行SQL出现异常，" + e.getMessage(), e);
                    }
                    /****
                     只有活跃状态的才验证是否积压
                     判断队列是否积压，如果是，则更新监控数据为2，代表当前topic消费有积压，并且超过5分钟
                     ****/
                    if (res && ThreadLimitUtil.hasStockRecords(monisql)) {
                        //设置监控结果为积压状态
                        exesql = "UPDATE TD_DSYNC_MONITOR_REC SET UPDTIME = SYSDATE, MONIVAL = 2 WHERE ID = '" + id + "'";
                        try {
                            rows = kafkaInfo.updMonitorBySql(exesql);
                            //System.out.println(id+"，执行SQL影响行："+rows);
                        } catch (Exception e) {
                            e.printStackTrace();
                            logger.error(exesql + "，执行SQL出现异常，" + e.getMessage(), e);
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("监控定时任务出现异常，" + e.getMessage(), e);
        }
    }
}
