package com.chinacreator.datasync.util;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * 参数配置类，用于非注入类使用配置文件的属性值
 * @author xu。zhou
 * @date 20210701
 */
@Component
public class ParamsConfig {
	//#CDN同步内存队列长度设置
	public static String queuelencdn;
	
	//#CP同步内存队列长度设置
	public static String queuelencp;
	
	//#KAFKA客户端每次取数据的条数
	public static String maxpollrecords;
	
	public static String autooffsetreset;
	
	//要替换CPID的SPID
	public static String replacecpidbusi;
	
	//退订不赠送流量的SPID
	public static String notaddmonthbusi;
	
	//退订赠送一个月流量开关
	public static String sendflowswitch;
	
	@Value("${config.sendflow.switch}")
	public void setSendflowswitch(String sendflowswitch){
		ParamsConfig.sendflowswitch = sendflowswitch;
	}
	
	@Value("${config.replacecpid.busi}")
	public void setReplacecpidbusi(String replacecpidbusi){
		ParamsConfig.replacecpidbusi = replacecpidbusi;
	}
	
	@Value("${config.notaddmonth.busi}")
	public void setNotaddmonthbusi(String notaddmonthbusi){
		ParamsConfig.notaddmonthbusi = notaddmonthbusi;
	}
	
	@Value("${config.auto.offset.reset}")
	public void setAutooffsetreset(String autooffsetreset){
		ParamsConfig.autooffsetreset = autooffsetreset;
	}
	
	
	@Value("${config.queue.len.cdn}")
	public void setQueuelencdn(String _queuelencdn){
		ParamsConfig.queuelencdn = _queuelencdn;
	}
	
	@Value("${config.queue.len.cp}")
	public void setQueuelencp(String _queuelencp){
		ParamsConfig.queuelencp = _queuelencp;
	}
	
	@Value("${config.max.poll.records}")
	public void setMaxpollrecords(String _maxpollrecords){
		ParamsConfig.maxpollrecords = _maxpollrecords;
	}
}
